module ce_gen(
	input clk,
	input rst,
	input ce,
	output logic ce_o
);
	parameter DIV_FACT = 2; // clock division factor (when 1 output is always set, 2 for ce_o once per two clock enables
	localparam CW = $clog2(DIV_FACT-1);

	generate
		if (DIV_FACT == 1)
			assign ce_o = ce;
		else begin
			logic [CW-1:0] cnt;

			always @(posedge clk) begin
				if (rst) begin
					ce_o <= 0;
					cnt <= 0;
				end else if (ce) begin
					ce_o <= 0;
					cnt <= cnt + 1'b1;
					if (cnt == DIV_FACT - 1) begin
						cnt <= 0;
						ce_o <= 1;
					end
				end
			end
		end
	endgenerate

endmodule
