module edge_detector(
  input  clk,
  input  ce,
  input  din,
  output reg edges,
  output reg pos_edge,
  output reg neg_edge
);

  reg din_prev;
  always @(posedge clk) begin
    if (ce) begin
      din_prev <= din;
      edges <= din ^ din_prev;
      pos_edge <= din & ~din_prev;
      neg_edge <= din_prev & ~din;
    end
  end

endmodule