module square_gen(
  input clk,
  input rst,
  input ce,
  output reg square
);

  parameter integer PERIOD = 88; // output period in ce cycles
  localparam integer HALF_PER = PERIOD / 2;

  wire change;

  ce_gen #(
  .DIV_FACT(HALF_PER)
  ) ce_gen_instance(
    .clk(clk),
    .rst(rst),
    .ce(ce),
    .ce_o(change)
  );

  always @(posedge clk) begin
    if (rst)
      square <= 0;
    else if (ce) begin
      if (change)
        square <= ~square;
    end
  end


endmodule
